#include "CSRPG.h"
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include <cstdio>
#include <cstdlib>

using namespace std;

/*
 * 	FightLoop.cpp
 * 	Holds the loop for fighting when the player gets stuck
 * 	in a hackneyed old-school RPG battle to the death!
 *
 * 	Changelog:
 * 		Mike, Apr 30
		Geoff, May 10
 */

int calculateDamage(int mod) {
	/*
		This is a simple d20, added on with a combat modifier
	*/
	return rand() % 20 + mod;
}

int hitSuccess(int attacker_mod, int target_mod) {
	/*
		This is a simple function to do a d20 roll to see if one character
		successfully strikes the other, or misses entirely
	*/
	if(rand() % 20 + attacker_mod > target_mod + rand() % 20) {
		// a successful hit!
		return 1;
	}
	else {
		// a miss!
		return 0;
	}
}

void CGame::FightLoop() {
	/*
		This is the loop where we get input from the player,
		display the current state of their brawl, and try to
		figure out whether or not the player or his enemy
		has met a grisly and unfortunate death.
	*/
	printf("Initializing fight roll\n");
	// local variables
	// display the game world!
	//char *tempstr = new char[40];
	//tempstr = "Nothin'";
	char* tempstr2 = new char[60];
	//tempstr2 = "Nothin'"; // just to make delete[] have something to work with -- STEVE'S NOTE: NEVER DO THIS EVER EVER EVER EVER, means "point tempstr2 to "nothin'", whatever that is
	SDL_Rect temprect = {0,0,0,0};
	temprect.x = 100;
	temprect.y = RES_Y - 400;
	temprect.w = 48;
	temprect.h = 48;
	printf("Initialized variables\n");
	// draw the background
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
	// draw the "hand painted" background
	// make sure it's centered -- this may slow down the PC in software mode!!!
	// have a toggle
	if(SLOW_PC == 0) {
		temprect.x = (RES_X - fightBackgrounds[fightBackground]->w) / 2;
		temprect.y = (RES_Y - fightBackgrounds[fightBackground]->h) / 2;
		SDL_BlitSurface(fightBackgrounds[fightBackground],NULL,screen,&temprect);
	}
	printf("Blitted background\n");
	// now draw the characters
	// draw you
	temprect.x = 100;
	temprect.y = RES_Y - 250;
	SDL_BlitSurface(chargfx[0][3],NULL,screen,&temprect); // draw you
	temprect.x = RES_X / 2 - 10; // position the NPC
	printf("Drawing sprite %i\n",targetNPC->sprite);
	SDL_BlitSurface(chargfx[targetNPC->sprite][1],NULL,screen,&temprect);
	printf("Blitted sprite %i\n",targetNPC->sprite);
	printf("Drawing player HUD...\n");
	HUD_Player();
	printf("Drew player HUD, drawing enemy HUD..\n");
	HUD_Enemy(targetNPC); // this is where it dies
	printf("Drew enemy HP/MP/etc\n");
	if(bPlayerTurn) {
		// sometimes it dies later O_O
		// display the menu and wait for the idiot to hit something
		// draw the menu
		SDL_Rect borderRect = {0,0,0,0}; // border around the menu
		borderRect.x = 0;
		borderRect.y = RES_Y - 68;
		borderRect.w = RES_X;
		borderRect.h = 67;
		SDL_FillRect(screen,&borderRect,SDL_MapRGB(screen->format,200,200,200)); // a nice gray
		SDL_Rect menuRect = {0,0,0,0};
		menuRect.x = 0;
		menuRect.y = RES_Y - 65;
		menuRect.w = RES_X;
		menuRect.h = 60; // give 5 px. at the bottom
		SDL_FillRect(screen,&menuRect,SDL_MapRGB(screen->format,0,0,195));
		SDL_Rect iconRect = {0,0,0,0};
		iconRect.x = 22;
		iconRect.y = RES_Y - 58;
		iconRect.w = 48;
		iconRect.h = 48;
		SDL_BlitSurface(icons[0],NULL,screen,&iconRect);
		iconRect.x += 49;
		SDL_BlitSurface(icons[1],NULL,screen,&iconRect);
		iconRect.x += 49;
		SDL_BlitSurface(icons[2],NULL,screen,&iconRect);
		iconRect.x += 49;
		SDL_BlitSurface(icons[4],NULL,screen,&iconRect);
		if(targetNPC->hp < 1) {
                            // obviously the person you attacked is the dead
                            //printf("You won!!\n");
                            displayFightConsoleMessage("You got your win on!!",0);
                            you.experience += 1; // probably best...
                            if(you.experience % 3 == 0) {
                                int level = you.experience / 3;
                                //printf("You just achieved level %i
                                //displayFightConsole
                                char *tempstr3 = new char[50];
                                sprintf(tempstr3,"You are now level %i",level);
                                displayFightConsoleMessage(tempstr3,0);
                                delete[] tempstr3;
                                //you.experience++; // don't really need this.
                                // specific spell "learnin'" generation.
                                if(level == 3) {
                                    you.bHasScornAndAbuse = 1;
                                    displayFightConsoleMessage("Learned spell: Scorn & Abuse",0);
                                }
                                else if(level == 6) {
                                    you.bHasMessiah = 1;
                                    displayFightConsoleMessage("Learned spell: The Messiah",0);
                                }
                                else if(level == 9) {
                                    /*bool bHasScornAndAbuse;
        /// Has Messiah spell, obtained at level 6.
        bool bHasMessiah;
        /// Has the Rapture spell, obtained at level 9.
        bool bHasTheRapture;*/
                                    //sprintf(tempstr3,"Gained 
                                    you.bHasTheRapture = 1;
                                    displayFightConsoleMessage("Learned spell: The Rapture",0);
                                }
                                
                                you.hp_max += 25;
                                you.hp = you.hp_max;
                                you.mp_max += 10;
                                you.mp = you.mp_max;
                                displayFightConsoleMessage("Recharged mana, health",0);
								//bPlayer
                            }
                            characters.remove(targetNPC);
                            delete targetNPC; // kill them
                            bPlayerTurn = 1;
                            bIsFighting = 0; // hooray you won
                            return; // remember to do this, otherwise the bloody
                                    // game will loop once more and die horribly.
                                    // horribly, i say
                        }
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				bIsDone = 1;
			}
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_z) {
					// attack
					if(hitSuccess(you.weapon_mod + 2,0)==1) {
						//printf("Hit enemy\n");
						int temp = calculateDamage(1);
						// memory leak city
						SDL_Rect rect;
						rect.x = (RES_X/2)-35;
						rect.y = RES_Y - 290;
						SDL_BlitSurface(fightEffects[0],NULL,screen,&rect);
						sprintf(tempstr2,"You hit %s for %i damage",targetNPC->myName.c_str(),temp);
						displayFightConsoleMessage(tempstr2,0);
						delete[] tempstr2;
						targetNPC->hp -= temp;
						if(targetNPC->hp < 1) {
							return;
						}
					} else {
						sprintf(tempstr2,"You missed %s",targetNPC->myName.c_str());
						displayFightConsoleMessage(tempstr2,1);
						delete[] tempstr2;
					}	
					bPlayerTurn = 0;
				}
				else if(event.key.keysym.sym == SDLK_x) {
					if(you.healingpotions > 0) {
						you.healingpotions--;
						displayFightConsoleMessage("Gained 15 health!",0);
						you.hp += 15;
						if(you.hp > you.hp_max) {
							you.hp = you.hp_max;
						}
						bPlayerTurn = 0;
					} else {
						displayFightConsoleMessage("No potions left.",1);
					}
				}
				else if(event.key.keysym.sym == SDLK_c) {
					bPlayerTurn = 0;
					Fight_magicMenu();
				}
				else if(event.key.keysym.sym == SDLK_v) {
					if(you.manapotions > 0) {
						displayFightConsoleMessage("Gained 15 mana!",0);
						you.mp += 15;
						if(you.mp > you.mp_max) {
							you.mp = you.mp_max;
						}
						bPlayerTurn = 0;
					} else {
						displayFightConsoleMessage("No potions left.",1);
					}
				}
				else if(event.key.keysym.sym == SDLK_F1) {
					/*
					hudctl.displayFightConsoleMessage("Press Z, X, or C to move",screen,0);
					hudctl.displayFightConsoleMessage("Z: Attack (sword)",screen,0);
					hudctl.displayFightConsoleMessage("X: Defend and heal",screen,0);
					hudctl.displayFightConsoleMessage("C: Magick",screen,0);*/
				}
				else if(event.key.keysym.sym == SDLK_ESCAPE) {
					printf("Exiting...\n");
					exit(0);
				}
			}
		}
		SDL_Delay(200);
	} else {
		// enemy attack!!!!
		if(hitSuccess(0,you.ac_mod) == 1) {
			printf("Enemy hit you\n");
			int temp = calculateDamage(0);
			sprintf(tempstr2,"%s hit you for %i damage",targetNPC->myName.c_str(),temp);
			printf("Wrote string\n");
			displayFightConsoleMessage(tempstr2,1);
			you.hp -= temp; // detract the damage
			if(you.hp < 1) {
				// you died...
				//printf("You died!!!!\n");
				displayFightConsoleMessage("You died....",1);
				if(you.bHasMessiah) {
					if(you.mp >= 10) {
						you.mp -= 10;
						SDL_Rect rect;
						rect.x = 100;
						rect.y = RES_Y - 300;
						SDL_BlitSurface(fightEffects[9],NULL,screen,&rect);
						displayFightConsoleMessage("Back from the grave!!!!",0);
						you.hp = you.hp_max;
					} else {
						displayFightConsoleMessage("Not enough MP to respawn...",1);
						exit(0);
					}
				} else {
					exit(0); // FIX THIS LATER
				}
			}
			delete[] tempstr2; // THIS CRASHES?
		} else {
			printf("Enemy missed\n");
			sprintf(tempstr2,"%s missed!",targetNPC->myName.c_str());
			printf("Wrote string\n");
			displayFightConsoleMessage(tempstr2,0);
			delete[] tempstr2; // only here when we use it
		}
		bPlayerTurn = 1;
		SDL_Delay(200);
	}
	//delete[] tempstr;
}
