#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include <cstdlib>
#include <cstdio>
#include <math.h>
#include "CSRPG.h"
using namespace std;

void CGame::gameLoop()
{
	float ctr_start = SDL_GetTicks();
	int frames = 0;
	while(!bIsDone) {
		frames++;
		if(bIsFighting) {
			FightLoop();
		} else {
			RoamLoop();
		}
		SDL_Flip(screen);
	}
	float ctr_elapsed = SDL_GetTicks() - ctr_start;
	ctr_elapsed /= 1000.0f; // convert to seconds
	FILE* statuslog = fopen("performance.txt","w");
	fprintf(statuslog,"RavProfiler 2.0\n====\n");
	fprintf(statuslog,"Did %i frames in %f seconds\n",frames,ctr_elapsed);
	fprintf(statuslog,"Had %i NPC's at %ix%i resolution\n",characters.size(),RES_X,RES_Y);
	float fps = frames / ctr_elapsed;
	fprintf(statuslog,"Avg. FPS: %f\n",fps);
	fclose(statuslog);
}
