#include "CSRPG.h"
#include "SDL.h"

/*
 * 	RoamDraw.cpp
 * 	Draws the map and sprites for the purposes of
 * 	the roaming world mode.
 *
 * 	Changelog:
 * 		Mike, Apr 30
 */

void CGame::Roam_DrawEverything() {
		// ok, fill the screen with black
	if(SLOW_PC == 1) {
		// my memory leak isn't here
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
	} else {
		// or here
		// this will probably suck up FPS,
		// if SLOW_PC mode is enabled make sure to take it
		// out back and shoot it in the head, just like ol' yeller
		// (TIMMY: "old yeller! nooooooooooo!")
		SDL_Rect *cloudTileRect = new SDL_Rect();
		for(int r = 0; r <= RES_Y / clouds->h; r++) {
			for(int c = 0; c <= RES_X / clouds->w; c++) {
				// draw "parallax" background
				cloudTileRect->x = c * clouds->w;
				cloudTileRect->y = r * clouds->h;
				cloudTileRect->w = 48;
				cloudTileRect->h = 48;
				SDL_BlitSurface(clouds,NULL,screen,cloudTileRect);
			}
		}
		delete cloudTileRect;
	}
		// now i want you to paint the tiles.
	paintTiles(); 
		// now paint the sprites on top of the tiles.
	// draw the HUD
	HUD_Player();
	drawItemsPotionsKeys(); // might mem leak
	/*
					HERE IS WHERE MY MEMORY LEAK IS!!!!!!!!!!!!!!!!!!!!!!!
	*/
	// draw HP: indicator, current quest
}

void CGame::drawSprite(int c, int r, SDL_Rect *temprect) {
	/*
		This should get the honour of being the least optimal
		tile-based routine ever made. Each NPC added can cut the frame
		rate by 5FPS or more.

		NOTE: FIXME: My memory leak is here!!! IT HAS TO BE
	*/
	if(you.x == c && you.y == r) {
		SDL_BlitSurface(chargfx[0][you.heading],NULL,screen,temprect);
		return;
	}
	list <NPC*>::iterator nit;
	// go through the list of NPC's and see if any of them are at this
	// tile.
	for(nit = characters.begin(); nit != characters.end(); nit++) {
		NPC* tn = *nit;
		if(tn->x == c && tn->y == r) {
			SDL_BlitSurface(chargfx[tn->sprite][tn->heading],NULL,screen,temprect);
			return; // obviously there are no more to draw on this particular tile
		}
		//delete tn;
	}
	//delete tn; // let's clean up
}

void CGame::paintTiles() {
	// TODO: Replace this with a "Smooth scrolling" routine from
	// 	Iain when it becomes available. I want to only paint the
	// 	tiles I can see, save us 1-2 fps or so.

	const int cutoff = CUTOFF_DISTANCE;
	
	SDL_Rect	*temprect = new SDL_Rect();
	SDL_Surface*	temptile;

	temprect->w = 48;
	temprect->h = 48;
	
	for(int c = 0; c < MAP_X_SIZE; c++) {
		for(int r = 0; r < MAP_Y_SIZE; r++) {
			// fudge these values to "reorient" sprites on the
			// tile
			if(abs(you.x - c) > cutoff || abs(you.y - r) > cutoff) {
				// tiles too far, clip them to save
				//SDL_FreeSurface(temptile);
			} else {
				temprect->x = (c * 48) - ((you.x*48)-(RES_X/2));
				temprect->y = (r * 48) - ((you.y*48)-(RES_Y/2));
	
				temptile = tiles[(int)theMap.level[r][c]-'0'];
				if(theMap.level[r][c] - '0' < 0 || !temptile) {
					temptile = tiles[0];
				}
				SDL_BlitSurface(temptile,NULL,screen,temprect);

				drawSprite(c,r,temprect);
			}
		}
	}
	delete temprect;
}
