#include "CSRPG.h"
#include "SDL.h"


/*
 * 	RoamLoop.cpp
 * 	Contains the loop for roaming around the game "overworld"
 * 	and going from map to map and talking to people.
 *
 * 	This is where most of the game resides
 *
 * 	Changelog:
 * 		Mike, Apr. 30
 */

void CGame::Roam_GetInput() {
	while(SDL_PollEvent(&event)) {
		if(event.type == SDL_QUIT) {
			bIsDone = 1;
		}
		if(event.type == SDL_KEYDOWN) {
			
			if(event.key.keysym.sym == SDLK_ESCAPE) {
				//bIsDone = 1;
				menuchoice = -1;
				menuoff = -1; // reset this so we're sure we're happy
				characterMenu(); // hit escape again here to quit
			}
			else if(event.key.keysym.sym == SDLK_RETURN) {
				Roam_CheckNPCConvo(you.x,you.y);
			}
			else if(event.key.keysym.sym == SDLK_F4) {
				SDL_SaveBMP(screen,"screenshot.bmp");
			}
		}
		// "hold down" keys
	}
	Uint8 *keystate = SDL_GetKeyState(NULL);
		if(keystate[SDLK_UP]) {
			if(tileCollision(you.x,you.y-1)==0) {
				if(you.moveRelative(0,-1)==1) {
					solvedQuestScreen();
				}
				else if(theMap.level[you.y][you.x]=='6') {
					// stairs down.
					you.map++;
					if(you.map > MAX_FLOORS) {
						printf("You won\n");
						exit(0);
					}
					char fname[20];
					sprintf(fname,"data/map%i.rav",you.map);
					theMap.loadMap(fname);
					you.questptr = NULL;
					clearNPCs();
					characters.clear();
					sprintf(fname,"data/npcs%i.rav",you.map);
					loadNPCs(fname);
					//loadNPCs("
				}
			}
			SDL_Delay(INPUT_DELAY);
		}
		else if(keystate[SDLK_DOWN]) {
			if(tileCollision(you.x,you.y+1)==0) {
				if(you.moveRelative(0,1)==1) {
					solvedQuestScreen();
				}
				else if(theMap.level[you.y][you.x]=='6') {
					// stairs down.
					you.map++;
					if(you.map > MAX_FLOORS) {
						printf("You won\n");
						exit(0);
					}
					char fname[20];
					sprintf(fname,"data/map%i.rav",you.map);
					theMap.loadMap(fname);
					clearNPCs();
					you.questptr = NULL;
					characters.clear();
					sprintf(fname,"data/npcs%i.rav",you.map);
					loadNPCs(fname);
					//loadNPCs("
				}
			}			
			SDL_Delay(INPUT_DELAY);
		}
		if(keystate[SDLK_LEFT]) {
			if(tileCollision(you.x-1,you.y)==0) {
				if(you.moveRelative(-1,0)==1) {
					solvedQuestScreen();
				}
				else if(theMap.level[you.y][you.x]=='6') {
					// stairs down.
					you.map++;
					if(you.map > MAX_FLOORS) {
						printf("You won\n");
						exit(0);
					}
					char fname[20];
					sprintf(fname,"data/map%i.rav",you.map);
					theMap.loadMap(fname);
					clearNPCs();
					characters.clear();
					you.questptr = NULL;
					sprintf(fname,"data/npcs%i.rav",you.map);
					loadNPCs(fname);
					//loadNPCs("
				}
			}			
			SDL_Delay(INPUT_DELAY);
		}
		else if(keystate[SDLK_RIGHT]) {
			if(tileCollision(you.x+1,you.y)==0) {
				if(you.moveRelative(1,0)==1) {
					solvedQuestScreen();
				}
				else if(theMap.level[you.y][you.x]=='6') {
					// stairs down.
					you.map++;
					if(you.map > MAX_FLOORS) {
						printf("You won\n");
						exit(0);
					}
					char fname[20];
					sprintf(fname,"data/map%i.rav",you.map);
					theMap.loadMap(fname);
					clearNPCs();
					you.questptr = NULL;
					characters.clear();
					sprintf(fname,"data/npcs%i.rav",you.map);
					loadNPCs(fname);
					//loadNPCs("
				}
			}			
			SDL_Delay(INPUT_DELAY);
		}
		if(CHEATER_MODE == 1) {
			if(keystate[SDLK_k]) {
				printf("CHEATER!!!!!!! Key added\n");
				you.gold--;
				you.keys++;
			}
			else if(keystate[SDLK_g]) {
				printf("CHEATER!!!!!!! Gold added\n");
				you.gold++;
				you.keys--;
			}
			else if(keystate[SDLK_TAB] && IS_FULLSCREEN != 1) {
				printf("Matrix console activated.\n");
				//hudctl.displayFightConsoleMessage("Look at command prompt for debug console",screen,1);
				int z = rand() % 3;
				if(z==1) {
					displayFightConsoleMessage("No.. no more tests, no more scientists.",1);
				} else if(z==2) {
					displayFightConsoleMessage("I'm coming out of the booth now!!!!",0);
				} else {
					displayFightConsoleMessage("Colours, colours out of space",1);
				}
				ConsoleLoop();
			}
		}
}

void CGame::Roam_CheckNPCConvo(int x, int y) {
	// check all adjacent tiles for NPC's
	list <NPC*>::iterator eit;
	printf("You = (%i,%i)\n",x,y);
	for(eit = characters.begin(); eit != characters.end(); eit++) {
		NPC* tn = *eit;
		for(int xoff = -1; xoff != 2; xoff++) {
			for(int yoff = -1; yoff != 2; yoff++) {
				if(tn->x == x + xoff && tn->y == y + yoff) {
					printf("NPC found relative to player: (%i,%i)\n",xoff,yoff);
					if(tn->bIsMrQuesty) {
						// add a quest to your "current quest" indicator
						you.questptr = initiateConversation(tn,you.map);
					} 
					else if(tn->bIsShopKeeper) {
						// Display the shop menu.
						initiateConversation(tn,you.map);
						shopKeeping();
					}
					else {
						initiateConversation(tn,you.map);
						if(tn->bIsHostile) {
							printf("Initializing fight...\n");
							// FIGHT INITIATED HERE
							bIsFighting = 1;
							targetNPC = tn;
							fightBackground = theMap.level[you.y][you.x] - '0';
							if(fightBackground > 0) {
								fightBackground = 1; // "indoors"
							} else {
								fightBackground = 0; // "outdoors" (grass)
							}
							// okay, this will drop you into the fight engine next turn
							printf("Fight engine activated, background %i\n",fightBackground);
						}
					}
				}
			}
		}
	}
}

void CGame::RoamLoop() {
	if(bIsFighting) {
		FightLoop(); // debug
	}
	Roam_DrawEverything();
	Roam_GetInput();
}
