#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "ravedit.h"

RavEditor::RavEditor() {
	screen = SDL_SetVideoMode(640,480,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	if(screen == NULL) {
		fprintf(stderr,"error: screen not initialized. %s\n",
			SDL_GetError());
		exit(1);
	}
	SDL_WM_SetCaption("RavEditor: Standard Mode","re");
	
/*
	tiles[0] = IMG_Load("../data/tiles/00.png");
	tiles[1] = IMG_Load("../data/tiles/01.png");
	tiles[2] = IMG_Load("../data/tiles/02.png");
*/

	tiles[0] = IMG_Load("../data/gfx/tiles/00.png");
	tiles[1] = IMG_Load("../data/gfx/tiles/01.png");
	tiles[2] = IMG_Load("../data/gfx/tiles/02.png");
	tiles[3] = IMG_Load("../data/gfx/tiles/03.png");
	tiles[4] = IMG_Load("../data/gfx/tiles/04.png");
	tiles[5] = IMG_Load("../data/gfx/tiles/05.png");
	tiles[6] = IMG_Load("../data/gfx/tiles/06.png");
	tiles[7] = IMG_Load("../data/gfx/tiles/07.png");

	for(int r=0;r<LVLH;r++) {
		for(int c = 0; c < LVLW;c++) {
			level[r][c] = '0'; // clear this thing out
		}
	}

	for(int i=0; i<MAX_TILES;i++) {
		if(tiles[i] == NULL) {
			fprintf(stderr,"Tile %i is missing.\n",i);
			fprintf(stderr,"Did you forget PNG support?\n");
			fprintf(stderr,"Is the file there??\n");
		} else {
			tiles[i] = SDL_ConvertSurface(tiles[i],screen->format,0);
		}
		printf("Tile %i added.\n",i);
	}

	selectedTile = 0;
	extendedMode = 0;
	scrollx = 0;
	scrolly = 0;
	atexit(SDL_Quit);
}
