#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#include "ravedit.h"

void RavEditor::FetchInput() {
	while(SDL_PollEvent(&event)) {
		if(event.type == SDL_QUIT) {
			exit(0);
		}
		if(event.type == SDL_MOUSEBUTTONDOWN) {
			int tx = (int)floor(event.button.x / 48) + (scrollx);
			int ty = (int)floor(event.button.y / 48) + (scrolly);
			char *title = new char[20];
			sprintf(title,"Clicked at: (%i,%i)",tx,ty);
			SDL_WM_SetCaption(title,"editor2");
			if(tx < LVLW && tx > -1 && ty > -1 && ty < LVLH) {
				// place new tile :)
				level[ty][tx] = '0' + selectedTile;
				// standard mode ONLY!!!!!!!
				// extended mode comes later :)
				// it will let you place 52 tiles (26 + 26)
				// from a-z and A-Z instead of the 0-9 num
				// system in standard mode!!!
			}
			delete title;
		}
		if(event.type == SDL_KEYDOWN) {
			if(event.key.keysym.sym==SDLK_TAB) {
				selectedTile++;
				if(selectedTile > MAX_TILES) {
					selectedTile = 0;
				}
				printf("Tile now: %i\n",selectedTile);
			}
			if(event.key.keysym.sym==SDLK_s) {
				saveMap("default.rav");
			}
			if(event.key.keysym.sym==SDLK_ESCAPE) {
				SDL_Quit();
				exit(0);
			}
			if(event.key.keysym.sym==SDLK_c) {
				printf("CLEARED MAP\n");
				printf("---\n");
				printf("I didn't save. If you want to save,\n");
				printf("Hit 'S', if you did something wrong,\n");
				printf("Hit ESCAPE to quit\n");
				for(int r = 0; r < LVLH; r++) {
					for(int c = 0; c < LVLW; c++) {
						level[r][c] = '0';
					}
				}
				printf("Map cleared...\n");
			}
			if(event.key.keysym.sym == SDLK_0) {
				selectedTile = 0;
			}
			else if(event.key.keysym.sym == SDLK_1) {
				selectedTile = 1;
			}
			else if(event.key.keysym.sym == SDLK_2) {
				selectedTile = 2;
			}
			else if(event.key.keysym.sym == SDLK_3) {
				selectedTile = 3;
			}
			else if(event.key.keysym.sym == SDLK_4) {
				selectedTile = 4;
			}
			else if(event.key.keysym.sym == SDLK_5) {
				selectedTile = 5;
			}
			else if(event.key.keysym.sym == SDLK_6) {
				selectedTile = 6;
			}
			else if(event.key.keysym.sym == SDLK_7) {
				selectedTile = 7;
			}
		}
	}
	Uint8 *keystate = SDL_GetKeyState(NULL);
	if(keystate[SDLK_LEFT]) {
		scrollx -= 1;
		SDL_Delay(50);
	}
	else if(keystate[SDLK_RIGHT]) {
		scrollx += 1;
		SDL_Delay(50);
	}
	if(keystate[SDLK_UP]) {
		scrolly -= 1;
		SDL_Delay(50);
	}
	else if(keystate[SDLK_DOWN]) {
		scrolly += 1;
		SDL_Delay(50);
	}
}
