#ifndef _RAVEDIT_H_
#define _RAVEDIT_H_

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

//using namespace std;

#define LVLH		100
#define LVLW		100
#define MAX_TILES	8

class PathNode {
	public:
		int tilex;
		int tiley;
		PathNode* next;
};

class RavEditor {
	public:
		SDL_Surface *screen;
		SDL_Event event;
		SDL_Surface *tiles[MAX_TILES + 1];

		char level[LVLH][LVLW];
		
		int selectedTile; // the tile the user has selected
		int scrollx; // upper limit of the "virtual screen"
		int scrolly;
		/*
		std::vector <PathNode*> pednodes;
		std::vector <PathNode*> carnodes;
		*/
		void FetchInput();
		void PaintTiles();
		void MainLoop();
		//void PaintNodes();

		bool extendedMode; 	// switch it from 1-10 tiles to a-Z tile
					// (game code needs to be rewritten
					//  for this)

		void loadMap(char *name);
		void saveMap(char *name);

		RavEditor();
};

#endif
