#include "SDL.h"
#include "SDL_image.h"
#include "freezer.h"
#include <vector>

// FIXME: Add entity placement support, and then entity loading support
// to level.cpp

using namespace std;

bool working = 1;

SDL_Surface *TTile;
SDL_Surface *cursor;
SDL_Surface *sHelp;
SDL_Rect cursrect;
SDL_Rect rHelp;

bool bHelp=1;

SDL_Surface *tiles[8];

int x = 4;
int y = 4;

void save(char level[LEVEL_HEIGHT][LEVEL_WIDTH]);

void Events(SDL_Event event, char level[LEVEL_HEIGHT][LEVEL_WIDTH])
{
	while(SDL_PollEvent(&event)) {
		switch(event.type) {
			case SDL_KEYDOWN:
				if(event.key.keysym.sym==SDLK_ESCAPE) {
					exit(0);
				}
				else if(event.key.keysym.sym==SDLK_UP) {
					if(y+4!=0) {
						y--;
					}
				}
				else if(event.key.keysym.sym==SDLK_DOWN) {
					if(y+4<LEVEL_HEIGHT) {
						y++;
					}
				}
				else if(event.key.keysym.sym==SDLK_LEFT) {
					if(x+4!=0) {
						x--;
					}
				}
				else if(event.key.keysym.sym==SDLK_RIGHT) {
					if(x+4<LEVEL_WIDTH) {
						x++;
					}
				}
				else if(event.key.keysym.sym==SDLK_s) {
					save(level);
				}
				else if(event.key.keysym.sym==SDLK_0) {
					level[y+4][x+4] = '0';
				}
				else if(event.key.keysym.sym==SDLK_1) {
					level[y+4][x+4] = '1';
				}
				else if(event.key.keysym.sym==SDLK_2) {
					level[y+4][x+4] = '2';
				}
				else if(event.key.keysym.sym==SDLK_3) {
					level[y+4][x+4] = '3';
				}
				else if(event.key.keysym.sym==SDLK_4) {
					level[y+4][x+4] = '4';
				}
				else if(event.key.keysym.sym==SDLK_5) {
					level[y+4][x+4] = '5';
				}
				else if(event.key.keysym.sym==SDLK_6) {
					level[y+4][x+4] = '6';
				}
				else if(event.key.keysym.sym==SDLK_7) {
					level[y+4][x+4] = '7';
				}
				else if(event.key.keysym.sym==SDLK_F1) {
					bHelp = !bHelp;
				}
			break;
		}
	}
}

void PaintLevel(char level[LEVEL_HEIGHT][LEVEL_WIDTH], SDL_Surface *screen)
{
	SDL_Rect *temprect = new SDL_Rect();
	temprect->w = 48;
	temprect->h = 48;
	for(int r = 0; r < LEVEL_HEIGHT; r++) { // row
		for(int c = 0; c < LEVEL_WIDTH; c++) { // col
			temprect->x = (c * 48) - x * 48;
			temprect->y = (r * 48) - y * 48;
			TTile = tiles[((int)level[r][c])-'0'];
			if(level[r][c]-'0' < 0) {
				TTile = tiles[0];
			}
			SDL_BlitSurface(TTile,NULL,screen,temprect);
		}
	}
	delete temprect;
}

void surfaces(SDL_Surface *screen)
{
	tiles[0] = IMG_Load("data/ourtiles/00.png");
	if(tiles[0] == NULL) {
		printf("WTF? Tile #0 not found\n");
		exit(1);
	}
	tiles[1] = IMG_Load("data/ourtiles/01.png");
	tiles[2] = IMG_Load("data/ourtiles/02.png");
	tiles[3] = IMG_Load("data/ourtiles/03.png");
	tiles[4] = IMG_Load("data/ourtiles/04.png");
	tiles[5] = IMG_Load("data/ourtiles/05.png");
	tiles[6] = IMG_Load("data/ourtiles/06.png");
	tiles[7] = IMG_Load("data/ourtiles/07.png");
	printf("Converting surfaces\n");
	for(int i=0;i<=7;i++) {
		tiles[i] = SDL_ConvertSurface(tiles[i],screen->format,0);
	}
	printf("Done conversion.\n");
	cursor = IMG_Load("editcurs.png");
	SDL_Surface *temp = SDL_DisplayFormatAlpha(cursor);
	SDL_FreeSurface(cursor);
	cursor = temp;
	
	sHelp = IMG_Load("overlay.png");
	temp = SDL_DisplayFormatAlpha(sHelp);
	SDL_FreeSurface(sHelp);
	sHelp = temp;
}

void Cursor(SDL_Surface *screen,SDL_Surface *cursor)
{
	//cursrect.x = x*48; // set the locs
	//cursrect.y = y*48;
	SDL_BlitSurface(cursor,NULL,screen,&cursrect);
}

void editorloop(char level[LEVEL_HEIGHT][LEVEL_WIDTH],SDL_Surface *screen)
{
	surfaces(screen);
	SDL_Event event;
	cursrect.w = 48;
	cursrect.h = 48;
	cursrect.x = x*48;
	cursrect.y = y*48;
	rHelp.x = 0;
	rHelp.y = 0;
	rHelp.w = sHelp -> w;
	rHelp.h = sHelp -> h;
	printf("Entered editor loop.\n");
	while(working = 1) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
		printf("Loc: (%i,%i)\n",x+4,y+4);
		PaintLevel(level,screen);
		Cursor(screen,cursor);
		if(bHelp==1) {
			SDL_BlitSurface(sHelp,NULL,screen,&rHelp);
		}
		Events(event,level);
		SDL_Flip(screen);
	}
}
