#ifndef _WEAPONS_H_
#define _WEAPONS_H_

/* Weapons.h
	Class declarations for weapons
*/

#include "SDL.h"
#include "SDL_image.h"
#include <stdlib.h>

using namespace std;

#define MAX_GUNS 4 // 0 = chainsaw, 1 = pistol, 2 = shotgun, 3 = ak-47
#define PISTOL_RANGE 80
#define SHOTGUN_RANGE 60
#define AK_RANGE 150

class cfWeapon {
	public:
		int ammo; // if ammo is empty the gun should be deleted
		int range;
		int damage; // these attributes carry over to ccWeapon
		int tilex;
		int tiley; // tile x and y: where am I?
		SDL_Rect rect;
		cfWeapon();
		virtual void drawMe(SDL_Surface *screen, SDL_Rect temprect)=0; // function to draw me

};

class ccWeapon {
	public:
		int ammo;
		int range;
		int damage;
		ccWeapon();
};

class cfPistol : public cfWeapon {
	public:
		void drawMe(SDL_Surface *screen, SDL_Rect temprect);
		cfPistol(){
			ammo = 40; // good ammo
			range = PISTOL_RANGE; // good range -- if change, change menu.cpp
			damage = 10; // poor damage
			// random for now; let's clean up later
			tilex = rand() % 25;
			tiley = rand() % 25;
			printf("I'm at (%i,%i)\n",tilex,tiley);
		}
};

class cfShotgun : public cfWeapon {
	public:
		void drawMe(SDL_Surface *screen, SDL_Rect temprect);
		cfShotgun() {
			ammo = 25; // poor ammo
			range = SHOTGUN_RANGE; // poor range
			damage = 100; // awesome damage
			tilex = rand() % 25;
			tiley = rand() % 25;
		}
};

class cfAK : public cfWeapon {
	public:
		void drawMe(SDL_Surface *screen, SDL_Rect temprect);
		cfAK() {
			ammo = 50; // good ammo
			range = AK_RANGE; // average range
			damage = 30; // good damage
			tilex = rand() % 25;
			tiley = rand() % 25;
		}
};

class cShot { // any bullet
	public:
		int xloc; // the current (x,y) pair of the bullet
		int yloc;
		SDL_Rect rect; // the rectangle
		bool renderMe;
		double heading;
		int rangecur; // rough estimate of how far you have gone
		int rangemax; // how far you can go (downloaded from you->gun)
		int damage; // how much damage the shot does on impact
				// downloaded from you->gun
		void updateGfx(int rectx, int recty, int xpos, int ypos);
		void drawMe(SDL_Surface *screen);
};

/*// basic fn definitions -- drawMe()s should be in gameloop
cfPistol::cfPistol() {
	ammo = 40; // good ammo
	range = 80; // remember, range is multiplied by 2 in shot handler
	damage = 20; // poor damage
	rect.x = 0;
	rect.y = 0;
	rect.w = 48;
	rect.h = 48;
}

cfShotgun::cfShotgun() {
	ammo = 25; // decent ammo
	range = 40; // multiply by two in the shot handling
	damage = 100; // shotguns are uberdeadly
	rect.x = 0;
	rect.y = 0;
	rect.w = 48;
	rect.h = 48;
}

cfAK::cfAK() {
	ammo = 50; // good ammo	
	range = 60; // good range
	damage = 50; // decent damage
	rect.x = 0;
	rect.y = 0;
	rect.w = 48;
	rect.h = 48;
}*/

#endif
