#include "CSRPG.h"
#include "Shops.h"

/*
	characterMenu.cpp
	Holds the prized character stats and equipment menu. Hooray
*/

void CGame::characterMenu() {
	bool bChosen = 0;
	if(menuchoice < 0) {
		menuchoice = you.yourStuff.size() - 1;
	}
	if(menuoff < 0) {
		menuoff = 0;
	}
	while(!bChosen) {
		// first, blank ze screen
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,150));
		// draw the character portrait
		SDL_Rect *rect = new SDL_Rect(); // deleted ok
		rect->x = 10;
		rect->y = 10;
		SDL_BlitSurface(portrait,NULL,screen,rect);
		// now draw the stats right to the side. let's assume we have a 640x480
		// screen, with a mere 128-pixel wide portrait
		rect->x += 130;
		//SDL_Surface *text = items[0]; // freed alright
		SDL_Color colour = {255,255,255,255};
		char *foo = new char[40]; // deleted ok
		//foo = "blank";
		sprintf(foo,"HP: %i/%i",you.hp,you.hp_max);
		SDL_Surface *text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text);
		rect->y += 30;
		sprintf(foo,"MP: %i/%i",you.mp,you.mp_max);
		text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text);
		rect->y += 30;
		sprintf(foo,"Weapon: %i",you.weapon_mod);
		text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text);
		rect->y += 30;
		sprintf(foo,"Armour: %i",you.ac_mod);
		text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text); // memleak protector
		rect->y += 30;
		sprintf(foo,"Exp: %i",you.experience);
		text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text); // memleak protector
		rect->y += 30;
		sprintf(foo,"Gold: %i",you.gold);
		text = TTF_RenderText_Solid(font,(const char*)foo,colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text); // memleak protector
		rect->y = RES_Y - 30;
		text = TTF_RenderText_Solid(font,"Press ESC to quit, SPACE to leave menu",colour);
		SDL_BlitSurface(text,NULL,screen,rect);
		SDL_FreeSurface(text);
		// Ok, now let's go over and display our inventory and menu :(((((((
		rect->x += 130;
		rect->y = 10;
		int drawn = 0; // temporary.

		if(you.yourStuff.size() == 0) {
			text = TTF_RenderText_Solid(font,"Nothing in inventory",colour);
			SDL_BlitSurface(text,NULL,screen,rect);
			SDL_FreeSurface(text);
		} else {
			
			//printf("You are at position %i in the array\n",menuchoice);
			for(int i = you.yourStuff.size() - 1; i > -1; i--) {
				if(i - menuoff < 0) {
					printf("Something broke... i-menuoff was out of range\n");
					break;
				}
				/// go through and list everything in your inventory.
				// scrolling should get implemented here later.
				if(you.yourStuff[i-menuoff]) {
					// detect if the item is worth painting.
					if(you.yourStuff[i-menuoff]->ac_mod > 0 || you.yourStuff[i-menuoff]->mod > 0) {
						// start by drawing the icon for the item.
						if(i-menuoff == menuchoice) {
							SDL_Rect temp;
							temp.x = rect->x;
							temp.y = rect->y;
							temp.w = 300;
							temp.h = 50;
							SDL_FillRect(screen,&temp,SDL_MapRGB(screen->format,100,0,0));
						}
						const char* tempstr = you.yourStuff[i-menuoff]->name.c_str();
						int ico = you.yourStuff[i-menuoff]->icon;
						SDL_BlitSurface(items[ico],NULL,screen,rect);
						// now start on drawing the text next to the weapon icon.
						rect->x += 48;
						text = TTF_RenderText_Solid(font,tempstr,colour);
						if(text) {
							SDL_BlitSurface(text,NULL,screen,rect);
							drawn++;
							SDL_FreeSurface(text);
						}
						// now check to see if it's equipped. if so, tell us as much.
						if(you.yourStuff[i-menuoff]->mod > 0) {
							if(you.yourStuff[i-menuoff]->mod == you.weapon_mod) {
								// this hack will likely break...
								rect->y += 20;
								text = TTF_RenderText_Solid(font,"Equipped",colour);
								SDL_BlitSurface(text,NULL,screen,rect);
								rect->y -= 20; // put it back
								SDL_FreeSurface(text);
							}
						}
						else if(you.yourStuff[i-menuoff]->ac_mod > 0) {
							if(you.yourStuff[i-menuoff]->ac_mod == you.ac_mod) {
								// probably unnecessary, but it gives me a warm feeling of security
								rect->y += 20;
								text = TTF_RenderText_Solid(font,"Equipped",colour);
								SDL_BlitSurface(text,NULL,screen,rect);
								rect->y -= 20; // put it back
								SDL_FreeSurface(text);
							}
						}
						rect->x -= 48; // back into icon pos
						rect->y += 49;

						// 


						if(menuoff > 0) {
							// draw scroll up icon
							SDL_Rect rect;
							rect.x = RES_X - 40;
							rect.y = 10;
							rect.w = 16;
							rect.h = 16;
							SDL_BlitSurface(icons[5],NULL,screen,&rect);
							//printf("Drawing up scroll icon\n");
						}
						if(drawn > 8) {
							if(you.yourStuff.size() - (menuoff + drawn) > 0) {
								// draw scroll down icon
								SDL_Rect rect;
								rect.x = RES_X - 40;
								rect.y = RES_Y - 40;
								rect.w = 16;
								rect.h = 16;
								//printf("Drawing down scroll icon\n"); // DEBUG ONLY!!!!
								SDL_BlitSurface(icons[6],NULL,screen,&rect);
							}
							break; // break out of the loop, we'll want our pinhead user to scroll
						}
						//delete tempstr;
					} // end if ac mod or weapon mod > 0
				} // end if you.yourStuff[i]
			}
		}

		// clean up to prevent memory leak!
		delete[] foo;
		delete rect;
		//SDL_FreeSurface(text);

		// now get the user's input to move the selection box around, and/or equip an item
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_ESCAPE) {
					bIsDone = 1;
					bChosen = 1;
				}
				if(event.key.keysym.sym == SDLK_SPACE) {
					// give us our memory back
					return;
				}
				if(event.type == SDL_KEYDOWN) {
					if(event.key.keysym.sym == SDLK_DOWN) {
						if(menuchoice > 0) {
							menuchoice--;
							//printf("You are at position %i in the array\n",menuchoice);
						}
						int size = you.yourStuff.size() - 1; // from 0... end
						printf("Screenpos:%i\n",((size-menuchoice)-menuoff));
						if((size-menuchoice)-menuoff > 8) {
							menuoff++;
						}
					}
					else if(event.key.keysym.sym == SDLK_UP) {
						if(menuchoice < you.yourStuff.size() - 1) {
							menuchoice++;
						}
						int size = you.yourStuff.size() - 1; // from 0... end
						printf("Screenpos:%i\n",((size-menuchoice)-menuoff));
						if((size-menuchoice)-menuoff < 0) {
							menuoff--;
						}
					}
					else if(event.key.keysym.sym == SDLK_RETURN) {
						// equip item
						if(you.yourStuff[menuchoice]->mod > 0) {
							// weapon
							you.weapon_mod = you.yourStuff[menuchoice]->mod;
						}
						if(you.yourStuff[menuchoice]->ac_mod > 0) {
							// armor.
							you.ac_mod = you.yourStuff[menuchoice]->ac_mod;
						}
					}
				}
			}
		}
		SDL_Flip(screen);
	}
}
