/*
	console.cpp
	Debug console for CSRPG development
	by Mike Stedman
*/

#include "CSRPG.h"
#include "Map.h"
#include <cstdio>
#include <cstdlib>
using namespace std;

void CGame::ConsoleLoop() {
	// foo
	bool bBeDone = 0;
	char input[20];
	while(!bBeDone) {
		fflush(stdout);
		//printf("debug:");
		cout << "matrix-admin: " << flush;
		//cin.getline(input,50);
		cin >> input;

		// check for recognized functions.
		if(strcmp(input,"exit")==0) {
			printf("Exiting...\n");
			bBeDone = 1;
		}
		else if(strcmp(input,"mem")==0) {
			printf("Memory dump:\n");
			printf("# Characters: %i\n",characters.size());
			printf("# Quests: %i\n",qm->quests.size());
			printf("# Items: %i\n",NormalShop.shopItems.size());
		}
		else if(strcmp(input,"help")==0) {
			printf("Commands:\n");
			printf("exit\tmem\thelp\n");
			printf("tport\taddgold\taddkeys\n");
			printf("unlock\trelock\theal\n");
			printf("stats\taddheal\tdie\n");
			printf("clearnpc hack\tshop\n");
			printf("colours\n");
		}
		else if(strcmp(input,"clearnpc")==0) {
			clearNPCs();
		}
		else if(strcmp(input,"colours")==0) {
			// palette molestation happens here
		}
		else if(strcmp(input,"tport")==0) {
			printf("x:");
			cin >> input;
			you.x = atoi(input);
			printf("y:");
			cin >> input;
			you.y = atoi(input);
			printf("Teleported. Type 'exit' to return to game\n");
		}
		else if(strcmp(input,"addgold")==0) {
			//you.gold++;
			printf("how much:");
			cin >> input;
			you.gold += atoi(input);
		}
		else if(strcmp(input,"addkeys")==0) {
			you.keys++;
		}
		else if(strcmp(input,"shop")==0) {
			printf("Shop mode enabled. When you exit here, the console will start again\n");
			shopKeeping();
		}
		else if(strcmp(input,"hack")==0) {
			printf("rav's hack mode enabled\n");
		}
		else if(strcmp(input,"heal")==0) {
			you.hp = you.hp_max;
			printf("Healed, type 'exit' to return to game\n");
		}
		else if(strcmp(input,"die")==0) {
			printf("You really don't want to do that, do you?\n");
			exit(0);
		}
		else if(strcmp(input,"addheal")==0) {
			you.healingpotions++;
		}
		else if(strcmp(input,"stats")==0) {
			printf("Player:\n");
			printf("---\n");
			printf("HP: %i/%i\n",you.hp,you.hp_max);
			printf("MP: %i/%i\n",you.mp,you.mp_max);
			printf("Strength: %i Agility: %i Weapon Modifier: %i\n",you.strength_mod,you.agility_mod,you.weapon_mod);
			printf("Healing Potions: %i\n",you.healingpotions);
			printf("Gold: %i\n",you.gold);
			printf("Keys: %i\n",you.keys);
			printf("Floor: %i\n",you.map);
		}
		else if(strcmp(input,"unlock")==0) {
			int doors = 0;
			// find all doors ('6') and turn to open ('2')
			for(int r = 0; r < MAP_Y_SIZE; r++) {
				for(int c = 0; c < MAP_X_SIZE; c++) {
					if(theMap.level[r][c] == '7') {
						theMap.level[r][c] = '2';
						doors++;
					}
				}
			}
			printf("Unlocked %i doors. Type 'exit' to return to game\n",doors);
		}
		else if(strcmp(input,"relock")==0) {
			int doors = 0;
			// find all open doors ('2') and turn to ('6')
			for(int r = 0; r < MAP_Y_SIZE; r++) {
				for(int c = 0; c < MAP_X_SIZE; c++) {
					if(theMap.level[r][c] == '2') {
						doors++;
						theMap.level[r][c] = '7';
					}
				}
			}
			printf("Locked %i doors. Type 'exit' to return to game\n",doors);
		}
		else {
			printf("Bad command\n");
		}
	}
}
