#include "CSRPG.h"
#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
#include <string>
using namespace std;

/*
 * 	main.cpp
 * 	Computer Science RPG main source file.
 * 	Loads the main() or SDL_main() (windows only) functions
 * 	and then punts our happy user into a title screen, then
 * 	initializes the game state and away we go.
 *
 * 	Changelog:
 * 		Mike, Apr 30
 */

#ifdef _WIN32
int SDL_main(int argc, char *argv[]) {
#else
int main(int argc, char *argv[]) {
#endif
	string GameName = "Computer Science RPG";
	string Author = "Mike Stedman, Corey Baker, Geoff Jackson";
	cout << GameName << " by " << Author << endl;

	CGame *game = new CGame();
	if(!game) {
		fprintf(stderr,"Out of memory!\n");
		fprintf(stderr,"Please make sure you have at least 32MB\n");
		fprintf(stderr,"free on your system\n");
		fprintf(stderr,"\t\t\t-rav\n");
		exit(1);
	}
	game->titleScreen();
	game->gameLoop();
	delete game;
	printf("Goodbye...\n");
	return 0;
}

void CGame::titleScreen() {
	// paint the title screen to the screen and wait for input
	SDL_Surface *title = IMG_Load("data/gfx/title.png");
	if(!title) { // file not found
		fprintf(stderr,"Oh no! The title screen image (title.png) is missing!\n");
		exit(1);
	}
	title = SDL_ConvertSurface(title,screen->format,0);
	SDL_Rect dummy = {0,0,0,0}; // just a dummy rectangle to tell us where
				    // to draw the initial surface
	// figure out the x,y locations so that we can draw the title screen
	// centered, no matter what screen resolution.
	// to change the screen resolution 
	dummy.x = (RES_X - title->w) / 2;
	dummy.y = (RES_Y - title->h) / 2;
	// ok, now wait until someone hits a key to stop drawing.
	bool bDone = 0;
	while(!bDone) 
	{
		SDL_BlitSurface(title,NULL,screen,&dummy);
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				exit(0);
			}
			else if(event.type == SDL_KEYDOWN) {
				bDone = 1;
			}
		}
		SDL_Flip(screen);
	}
	// ok, they exited the title loop, now we should
	// probably clear up the title screen image to save some memory
	SDL_FreeSurface(title);
	printf("Welcome to the game...\n");
}
