#ifndef _NPC_H_
#define _NPC_H_

#include "SDL.h"

#include <cstdlib>
#include <string>
using namespace std;

/// Non-player characters.
/** A simple non-player character (NPC) class that contains
 *  statistics and a number of conditionals to see if the character
 *  is a "special" character (like Mr. Questy or Mr. Shoppy).
 *
 *  The Player class inherits from this!!!
 */
class NPC {
	public:
		/// Constructor -- sets variables and defaults
		NPC();
		// AD&D-style stat variables
		/// Current health points
		int hp;		
		/// Maximum number of obtainable health points
		int hp_max;	
		/// Current magic points
		int mp;		
		/// Maximum obtainable magic points
		int mp_max;	
		/// Attack modifier.
		int mod;

		// NPC management variables
		/// Will this NPC start a fight upon talking?
		bool bIsHostile;
		/// Obviously, the name of the NPC. STL String
		string myName;
		/// Their one-liner of conversation. STL String
		string whatToSay0; 
		/// Their location in the world.
		int x, y; 

		// RPG-based crap
		/// Tells the game engine whether or not this character can give quests.
		bool bIsMrQuesty; 
		/// Tells the game engine whether or not this character brings up the shop menu.
		bool bIsShopKeeper; 

		// graphics crap
		//bool bDrawMe; 
		//void updateGfx();
		/// Their location drawn on the screen
		SDL_Rect rect;
		/// What sprite number should we pull out?
		int sprite; 
		/// What direction (0-3) is the character facing?
		int heading; 

		// now for their usability functions
		/// Tells the NPC to move x,y tiles relatively.
		void moveRelative(int dx, int dy); 
};

#endif
